Graphics3D 512, 512, 0, 2
SetBuffer BackBuffer()

;Light = CreateLight()
;AlignToVector Light, 0.0, -1.0, 0.0, 3

;Cam = CreateCamera()
;MoveEntity Cam, 0.0, 6.0, -0.0
;CameraProjMode Cam, 2
;CameraZoom Cam, 0.25
;TurnEntity Cam, 90.0, 0.0, 0.0

Const AO_SIZE = 32

Local X#[ 7 ], Z#[ 7 ]

X[ 0 ] = -1.0 : Z[ 0 ] =  1.0
X[ 1 ] =  0.0 : Z[ 1 ] =  1.0
X[ 2 ] =  1.0 : Z[ 2 ] =  1.0
X[ 3 ] = -1.0 : Z[ 3 ] =  0.0
X[ 4 ] =  1.0 : Z[ 4 ] =  0.0
X[ 5 ] = -1.0 : Z[ 5 ] = -1.0
X[ 6 ] =  0.0 : Z[ 6 ] = -1.0
X[ 7 ] =  1.0 : Z[ 7 ] = -1.0

Global RotX#, RotY#, RotZ#

For I = 0 To %11111111
	LockBuffer
	SeedRnd 1337
	For U = 0 To AO_SIZE - 1
		For V = 0 To AO_SIZE - 1
			Local XPos# = U/Float( AO_SIZE )
			Local ZPos# = 1.0 - V/Float( AO_SIZE )
			
			For T = 0 To 7
				If I And ( 1 Shl T ) Then
					Local Pivot = CreatePivot()
					
					Local Scale# = 1.01
					
					Local CenterX# = X[ T ]*Scale# + 1.0/Scale#*0.5
					Local CenterZ# = Z[ T ]*Scale# + 1.0/Scale#*0.5
					
					Local DX# = Abs( XPos# - CenterX# )
					Local DZ# = Abs( ZPos# - CenterZ# )
					
					If DX# > DZ# Then Max# = DX# Else Max# = DZ#
					
					EntityBox Pivot, X[ T ]*Scale#, 0.0, Z[ T ]*Scale#, 1.0/Scale#, 1.5 - Max#, 1.0/Scale#
					EntityPickMode Pivot, 3
				EndIf
			Next
			
			Local HitCount = 0
			For F = 1 To 1000
				Local VX# = Rnd( -1, 1 )*5.0
				Local VY# = Rnd(  0, 1 )*5.0
				Local VZ# = Rnd( -1, 1 )*5.0
				
				If LinePick( XPos#, 0.0, ZPos#, VX#, VY#, VZ# ) Then HitCount = HitCount + 1
			Next
			
			WritePixelFast U + ( ( I ) Mod 16 )*AO_SIZE, V + ( ( I )/16 )*AO_SIZE, Floor( ( 1.0 - HitCount/1000.0 )*255 )*$010101
			
			ClearWorld True
		Next
	Next
	UnlockBuffer
	
	Flip 0
Next

LockBuffer BackBuffer()
SaveImageToPNG BackBuffer(), "AOTest.png", 9

WaitKey()
End

Function RotateAroundAxis( VectorX#, VectorY#, VectorZ#, AxisX#, AxisY#, AxisZ#, Angle# )
	Local C# = Cos( Angle# )
	Local S# = Sin( Angle# )
	
	RotX# = VectorX#*( AxisX#*AxisX# + ( 1 - AxisX#*AxisX# )*C# ) + VectorY#*( AxisX#*AxisY#*( 1 - C# ) - AxisZ#*S# )     + VectorZ#*( AxisX#*AxisZ#*( 1 - C# ) + AxisY#*S#     )
	RotY# = VectorX#*( AxisX#*AxisY#*( 1 - C# ) + AxisZ#*S#     ) + VectorY#*( AxisY#*AxisY# + ( 1 - AxisY#*AxisY# )*C# ) + VectorZ#*( AxisY#*AxisZ#*( 1 - C# ) - AxisX#*S#     )
	RotZ# = VectorX#*( AxisX#*AxisZ#*( 1 - C# ) - AxisY#*S#     ) + VectorY#*( AxisY#*AxisZ#*( 1 - C# ) + AxisX#*S#     ) + VectorZ#*( AxisZ#*AxisZ# + ( 1 - AxisZ#*AxisZ# )*C# )
End Function

Function AddQuad( Surface, X#, Y#, Z#, DoUV )
	Local V1 = AddVertex( Surface, X# - 0.5, Y#, Z# + 0.5 )
	Local V2 = AddVertex( Surface, X# + 0.5, Y#, Z# + 0.5 )
	Local V3 = AddVertex( Surface, X# + 0.5, Y#, Z# - 0.5 )
	Local V4 = AddVertex( Surface, X# - 0.5, Y#, Z# - 0.5 )
	
	If DoUV Then
		VertexTexCoords Surface, V1, 0.0, 0.0
		VertexTexCoords Surface, V2, 1.0, 0.0
		VertexTexCoords Surface, V3, 1.0, 1.0
		VertexTexCoords Surface, V4, 0.0, 1.0
	EndIf
	
	For I = V1 To V4
		VertexNormal Surface, I, 0.0, 1.0, 0.0
	Next
	
	AddTriangle Surface, V1, V2, V3
	AddTriangle Surface, V1, V3, V4
End Function

Function AddBox( Mesh, Surface, X1#, Y1#, Z1#, X2#, Y2#, Z2# )
	;Local Cube = CreateCube()
	;FitMesh Cube, X1#, Y1#, Z1#, X2# - X1#, Y2# - Y1#, Z2# - Z1#
	
	;AddMesh Cube, Mesh
	
	;FreeEntity Cube
	
	;Return
	
	Local V1 = AddVertex( Surface, X1#, Y2#, Z1# )
	Local V2 = AddVertex( Surface, X1#, Y2#, Z2# )
	Local V3 = AddVertex( Surface, X2#, Y2#, Z2# )
	Local V4 = AddVertex( Surface, X2#, Y2#, Z1# )
	Local V5 = AddVertex( Surface, X1#, Y1#, Z1# )
	Local V6 = AddVertex( Surface, X1#, Y1#, Z2# )
	Local V7 = AddVertex( Surface, X2#, Y1#, Z2# )
	Local V8 = AddVertex( Surface, X2#, Y1#, Z1# )
	
	AddTriangle Surface, V5, V6, V7
	AddTriangle Surface, V5, V7, V8
	
	AddTriangle Surface, V4, V7, V3
	AddTriangle Surface, V4, V8, V7
	
	AddTriangle Surface, V2, V5, V1
	AddTriangle Surface, V2, V6, V5
	
	AddTriangle Surface, V1, V8, V4
	AddTriangle Surface, V1, V5, V8
	
	AddTriangle Surface, V3, V6, V2
	AddTriangle Surface, V3, V7, V6
	
	Return V1
End Function