Global MX, MY, MH1, MD1, MH2, MD2, MH3, MD3

Global UIActive = False

Type TMainMenu
	Field Window.TWindow
	
	Field Singleplayer.TGadget
	Field Multiplayer.TGadget
	Field Options.TGadget
	Field Quit.TGadget
End Type
Global MainMenu.TMainMenu = New TMainMenu

Type TClientServer
	Field Window.TWindow
	
	Field Name.TGadget
	Field IP.TGadget
	Field Client.TGadget
	Field Server.TGadget
End Type
Global ClientServer.TClientServer = New TClientServer

Type TLobby
	Field Window.TWindow
	
	Field Start.TGadget
	Field PlayerList.TGadget
	Field PlayerPing.TGadget
	Field Chat.TGadget
	Field ChatWrite.TGadget
	Field Kick.TGadget
End Type
Global Lobby.TLobby = New TLobby

Type TGenerateMap
	Field Window.TWindow
	
	Field Generate.TGadget
End Type
Global GenerateMap.TGenerateMap = New TGenerateMap

Type TIngameChat
	Field Window.TWindow
	
	Field Chat.TGadget
	Field ChatWrite.TGadget
End Type
Global IngameChat.TIngameChat = New TIngameChat

Type TOptionSetup
	Field Window.TWindow
	
	Field GraphicsMode.TGadget
	Field FullScreen.TGadget
	Field VisibilityRange.TGadget
	Field AmbientOcclusion.TGadget
	Field CursorEnabled.TGadget
	Field MapSize.TGadget
	Field Back.TGadget
End Type
Global OptionSetup.TOptionSetup = New TOptionSetup

Type TPlayerList
	Field Window.TWindow
	
	Field PlayerList.TGadget
	Field Ping.TGadget
	Field Bandwidth.TGadget
	Field PacketLoss.TGadget
End Type
Global PlayerList.TPlayerList = New TPlayerList

Function InitGUI()
	Init3D( True )
	
	Style.TGUIStyle = LoadStyle( "Data\GUI.style" )
	
	SetGUIStyle Style
End Function

Function CreateMainMenuWindow()
	If MainMenu\Window <> Null Then DestroyWindow( MainMenu\Window )
	
	Local WindowH = 300
	Local WindowW = 200
	
	MainMenu\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Hauptmen", GUI_A_CENTER, GUI_W_LOCKED + GUI_W_TITLEBAR )
	
	Local ButtonX = 20
	Local ButtonY = 20
	Local ButtonH = 40
	
	MainMenu\Singleplayer = CreateButton( MainMenu\Window, ButtonX, ButtonY + 0*( ButtonY + ButtonH ), WindowW - ButtonX*2, ButtonH, "Singleplayer" )
	MainMenu\Multiplayer  = CreateButton( MainMenu\Window, ButtonX, ButtonY + 1*( ButtonY + ButtonH ), WindowW - ButtonX*2, ButtonH, "Multiplayer" )
	MainMenu\Options      = CreateButton( MainMenu\Window, ButtonX, ButtonY + 2*( ButtonY + ButtonH ), WindowW - ButtonX*2, ButtonH, "Optionen" )
	MainMenu\Quit         = CreateButton( MainMenu\Window, ButtonX, ButtonY + 3*( ButtonY + ButtonH ), WindowW - ButtonX*2, ButtonH, "Beenden" )
End Function

Function UpdateMainMenuWindow()
	If MainMenu\Singleplayer\Clicked
		StartSingleplayer()
		
		HideMainMenuWindow()
		
		ChangeState( STATE_GAME_SINGLE )
	ElseIf MainMenu\Multiplayer\Clicked
		HideMainMenuWindow()
		
		CreateClientServerWindow()
		
		ChangeState( STATE_CLIENT_SERVER )
	ElseIf MainMenu\Options\Clicked
		HideMainMenuWindow()
		
		CreateOptionSetupWindow()
		
		ChangeState( STATE_OPTIONS )
	ElseIf MainMenu\Quit\Clicked
		QuitGame()
	EndIf
End Function

Function HideMainMenuWindow()
	MainMenu\Window\Visible = False
End Function

Function CreateClientServerWindow()
	If ClientServer\Window <> Null Then DestroyWindow( ClientServer\Window )
	
	Local WindowH = 200
	Local WindowW = 200
	
	ClientServer\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Client/Server", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	CreateLabel( ClientServer\Window, 18, 20, 37, 22, "Name:", GUI_A_RIGHT )
	ClientServer\Name   = CreateTextfield( ClientServer\Window, 60, 17, 120, 22, Config\Name$ )
	CreateLabel( ClientServer\Window, 18, 50, 37, 22, "IP:",   GUI_A_RIGHT )
	ClientServer\IP     = CreateTextfield( ClientServer\Window, 60, 47, 120, 22, Config\IP$ )
	ClientServer\Server = CreateButton( ClientServer\Window, 30,  90, WindowW - 60, 30, "Server starten" )
	ClientServer\Client = CreateButton( ClientServer\Window, 30, 130, WindowW - 60, 30, "Client starten" )
End Function

Function UpdateClientServerWindow()
	If ClientServer\Client\Clicked Then
		Config\Name$ = ClientServer\Name\Caption$
		Config\IP$ = ClientServer\IP\Caption$
		SaveConfig( Config )
		
		InitPlayer( ClientServer\Name\Caption$, False )
		
		InitNetwork()
		ClientConnect( ClientServer\IP\Caption$ )
		
		HideClientServerWindow()
		
		CreateLobbyWindow()
		
		ChangeState( STATE_LOBBY )
	ElseIf ClientServer\Server\Clicked Then
		Config\Name$ = ClientServer\Name\Caption$
		SaveConfig( Config )
		
		InitPlayer( ClientServer\Name\Caption$, True )
		
		InitNetwork()
		
		HideClientServerWindow()
		
		CreateLobbyWindow()
		
		ChangeState( STATE_LOBBY )
	EndIf
End Function

Function HideClientServerWindow()
	ClientServer\Window\Visible = False
End Function

Function CreateLobbyWindow()
	If Lobby\Window <> Null Then DestroyWindow( Lobby\Window )
	
	Local WindowH = 400
	Local WindowW = 600
	
	Lobby\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Lobby", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	Lobby\PlayerList = CreateListBox( Lobby\Window, 20, 20, WindowW - 50, 15, ( WindowH - 250 )/15 )
	Lobby\PlayerPing = CreateLabel( Lobby\Window, WindowW - 80, 20, WindowW - 50, ( WindowH - 250 )/15 )
	Lobby\Chat = CreateLabel( Lobby\Window, 20, WindowH - 220, WindowW - 50, 160 )
	CreateLabel( Lobby\Window, 20, WindowH - 58, 50, 20, "Chat:" )
	Lobby\ChatWrite = CreateTextField( Lobby\Window, 60, WindowH - 60, WindowW - 160, 20 )
	
	If IsHost Then
		Lobby\Start = CreateButton( Lobby\Window, WindowW - 80, WindowH -  70, 70, 30, "Starten" )
		Lobby\Kick  = CreateButton( Lobby\Window, WindowW - 80, WindowH - 225, 50, 20, "Kick" )
	EndIf
End Function

Function UpdateLobbyWindow()
	Local Index = ListboxMarkedEntryIndex( Lobby\PlayerList )
	ListboxClear( Lobby\PlayerList )
	
	Local Caption$ = "", Counter
	For Player.TPlayer = Each TPlayer
		AddListboxEntry( Lobby\PlayerList, Player\Name$ )
		If Player\PeerID >= 0 Then Caption$ = Caption$ + Player\Ping + "ms"
		Caption$ = Caption$ + Chr( 10 )
		
		Counter = Counter + 1
	Next
	If Index > Counter Then Index = Counter
	
	ListboxMarkEntry( Lobby\PlayerList, Index )
	SetLabelCaption( Lobby\PlayerPing, Caption$ )
	
	Caption$ = ""
	Local Chat.TChat = Last TChat
	While Chat <> Null
		Caption$ = Chat\Message$ + Chr( 10 ) + Caption$
		
		SetLabelCaption( Lobby\Chat, Caption$ )
		
		If CountOccurenceInString( Lobby\Chat\Caption$, Chr( 10 ) ) > 9 Then Exit
		
		Chat = Before Chat
	Wend
	
	Local Count = CountOccurenceInString( Lobby\Chat\Caption$, Chr( 10 ) )
	
	If Count > 9 Then Caption$ = StripOccurenceInString( Lobby\Chat\Caption$, Chr( 10 ), Count - 9 )
	
	SetLabelCaption( Lobby\Chat, Caption$ )
	
	If KeyHit( 28 ) And Trim( Lobby\ChatWrite\Caption$ ) <> "" Then
		AddChat        ( "<" + LocalPlayer\Name$ + "> " + Lobby\ChatWrite\Caption$ )
		NetworkSendChat( "<" + LocalPlayer\Name$ + "> " + Lobby\ChatWrite\Caption$ )
		
		Lobby\ChatWrite\Caption$ = ""
	EndIf
	
	If IsHost Then
		If Lobby\Start\Clicked Then
			NetworkSendGenerateMap()
			
			ChangeState( STATE_GENERATE_MAP )
			
			HideLobbyWindow()
			CreateGenerateMapWindow()
			
			SingleUIRender()
			
			GenerateMap()
			InitPlayer3D()
		ElseIf Lobby\Kick\Clicked Then
			Index = ListboxMarkedEntryIndex( Lobby\PlayerList )
			
			Counter = 1
			For Player.TPlayer = Each TPlayer
				If Counter = Index Then
					NetworkSendPlayerKick( Player )
					
					KickPlayer( Player )
					
					Exit
				EndIf
				
				Counter = Counter + 1
			Next
		EndIf
	EndIf
End Function

Function HideLobbyWindow()
	Lobby\Window\Visible = False
End Function

Function CreateGenerateMapWindow()
	If GenerateMap\Window <> Null Then DestroyWindow( GenerateMap\Window )
	
	Local WindowW = 250
	Local WindowH = 60
	
	GenerateMap\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Generiere Karte", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	GenerateMap\Generate = CreateLabel( GenerateMap\Window, 9, 5, WindowW - 5, 300, "Generiere Karte..." )
End Function

Function UpdateGenerateMapWindow()
	If IsHost Then
		Local Caption$ = "Warte auf folgende Spieler:" + Chr( 10 )
		
		GenerateMap\Window\Height = 60
		
		Local StillGenerating
		For Player.TPlayer = Each TPlayer
			If Player <> LocalPlayer And ( Not Player\DoneGenerating ) Then
				Caption$ = Caption$ + "        " + Player\Name$ + Chr( 10 )
				
				StillGenerating = True
				
				GenerateMap\Window\Height = GenerateMap\Window\Height + 16
			EndIf
		Next
		
		SetLabelCaption( GenerateMap\Generate, Caption$ )
		
		If Not StillGenerating Then
			StartMultiplayer()
			
			NetworkSendStartGame()
			
			ChangeState( STATE_GAME_MULTI )
			
			HideGenerateMapWindow()
		EndIf
	Else
		Local NewCaption$ = "Warte auf andere Spieler"
		If GenerateMap\Generate\Caption$ <> NewCaption$ Then
			NetworkSendDoneGenerating()
			
			SetLabelCaption( GenerateMap\Generate, NewCaption$ )
		EndIf
	EndIf
End Function

Function HideGenerateMapWindow()
	GenerateMap\Window\Visible = False
End Function

Function CreateIngameChatWindow()
	If IngameChat\Window <> Null Then Destroywindow( IngameChat\Window )
	
	Local WindowW = Config\GWidth
	Local WindowH = 140
	
	IngameChat\Window = CreateWindow( 0, -30, WindowW, WindowH, "Chat", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	IngameChat\Chat = CreateLabel( IngameChat\Window, 9, 5, WindowW - 18, WindowH - 40, "" )
	IngameChat\ChatWrite = CreateTextField( IngameChat\Window, 9, WindowH - 45, WindowW - 18, 25 )
	IngameChat\ChatWrite\Visible = False
End Function

Function UpdateIngameChatWindow()
	Local Caption$ = ""
	Local Chat.TChat = Last TChat
	While Chat <> Null
		Caption$ = Chat\Message$ + Chr( 10 ) + Caption$
		
		SetLabelCaption( IngameChat\Chat, Caption$ )
		
		If CountOccurenceInString( IngameChat\Chat\Caption$, Chr( 10 ) ) > 5 Then Exit
		
		Chat = Before Chat
	Wend
	
	Local Count = CountOccurenceInString( IngameChat\Chat\Caption$, Chr( 10 ) )
	
	If Count > 5 Then Caption$ = StripOccurenceInString( IngameChat\Chat\Caption$, Chr( 10 ), Count - 5 )
	
	SetLabelCaption( IngameChat\Chat, Caption$ )
	
	If KeyHit( 28 ) Then
		If IngameChat\ChatWrite\Visible Then
			If Trim( IngameChat\ChatWrite\Caption$ ) <> "" Then
				Local Msg$ = IngameChat\ChatWrite\Caption$
				
				If Left( Msg$, 1 ) = "/" Then
					If LocalPlayer\PeerID = SERVER_PEER_ID Then
						Local SpaceIndex = Instr( Msg$, " " )
						
						If Not SpaceIndex Then SpaceIndex = Len( Msg$ )
						
						Local Command$ = Mid( Msg$, 2, SpaceIndex - 2 )
						
						Select Lower( Command$ )
							Case "kick"
								Local PlayerName$ = Mid( Msg$, SpaceIndex + 1 )
								
								Local PlayerKicked
								For Player.TPlayer = Each TPlayer
									If Lower( Player\Name$ ) = Lower( PlayerName$ ) Then
										NetworkSendPlayerKick( Player )
										
										KickPlayer( Player )
										
										PlayerKicked = True
										
										Exit
									EndIf
								Next
								
								If Not PlayerKicked Then AddChat( "Player " + PlayerName$ + " does not exist" )
						End Select
					Else
						NetworkSendChat( Msg$ )
					EndIf
				Else
					AddChat        ( "<" + LocalPlayer\Name$ + "> " + Msg$ )
					NetworkSendChat( "<" + LocalPlayer\Name$ + "> " + Msg$ )
				EndIf
				
				IngameChat\ChatWrite\Caption$ = ""
			EndIf
			
			IngameChat\Window\Height = IngameChat\Window\Height - 20
			
			FlushKeys()
			MouseXSpeed()
			MouseYSpeed()
		Else
			FlushKeys()
			
			IngameChat\Window\Height = IngameChat\Window\Height + 20
		EndIf
		
		IngameChat\ChatWrite\Visible = Not IngameChat\ChatWrite\Visible
		IngameChat\ChatWrite\Active = IngameChat\ChatWrite\Visible
		UIActive = IngameChat\ChatWrite\Active
	EndIf
End Function

Function HideIngameChatWindow()
	IngameChat\Window\Visible = False
End Function


Function CreateOptionSetupWindow()
	If OptionSetup\Window <> Null Then DestroyWindow( OptionSetup\Window )
	
	Local WindowW = 200
	Local WindowH = 300
	
	OptionSetup\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Optionen", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	CreateLabel( OptionSetup\Window, 20, 10, 100, 15, "Grafikmodus:" )
	OptionSetup\GraphicsMode = CreateCombobox( OptionSetup\Window, 40, 30, 110, 17 )
	OptionSetup\FullScreen       = CreateCheckbox( OptionSetup\Window, 40, 52, 110, 20, "Vollbild" )
	OptionSetup\AmbientOcclusion = CreateCheckbox( OptionSetup\Window, 40, 72, 110, 20, "Ambient Occlusion" )
	OptionSetup\CursorEnabled    = CreateCheckbox( OptionSetup\Window, 40, 92, 110, 20, "3D Cursor" )
	CreateLabel( OptionSetup\Window, 20, 120, 100, 20, "Mapgrsse:" )
	OptionSetup\MapSize = CreateCombobox( OptionSetup\Window, 40, 143, 110, 17 )
	CreateLabel( OptionSetup\Window, 20, 170, 100, 20, "Sichtweite:" )
	OptionSetup\VisibilityRange = CreateCombobox( OptionSetup\Window, 40, 193, 110, 17 )
	OptionSetup\Back = CreateButton( OptionSetup\Window, WindowW/2 - 50, 225, 100, 30, "Zurck" )
	
	OptionSetup\FullScreen\Pressed = ( Config\FullScreen <> 0 )
	OptionSetup\AmbientOcclusion\Pressed = ( Config\AmbientOcclusion <> 0 )
	OptionSetup\CursorEnabled\Pressed = ( Config\CursorEnabled <> 0 )
	
	Local SelectedEntry
	For I = 1 To CountGfxModes()
		Local Width = GfxModeWidth( I )
		Local Height = GfxModeHeight( I )
		
		If GfxModeDepth( I ) = 32 Then
			AddComboboxEntry( OptionSetup\GraphicsMode, Width + "x" + Height )
			
			If Width = Config\GWidth And Height = Config\GHeight Then SelectedEntry = ComboboxMarkedEntryIndex( OptionSetup\GraphicsMode )
		EndIf
	Next
	
	If SelectedEntry Then ComboboxSelectEntry( OptionSetup\GraphicsMode, SelectedEntry )
	
	AddComboboxEntry( OptionSetup\MapSize, "Klein" )
	AddComboboxEntry( OptionSetup\MapSize, "Mittel" )
	AddComboboxEntry( OptionSetup\MapSize, "Gross" )
	AddComboboxEntry( OptionSetup\MapSize, "Riesig" )
	
	AddComboboxEntry( OptionSetup\VisibilityRange, "Niedrig" )
	AddComboboxEntry( OptionSetup\VisibilityRange, "Mittel" )
	AddComboboxEntry( OptionSetup\VisibilityRange, "Hoch" )
	AddComboboxEntry( OptionSetup\VisibilityRange, "Sehr hoch" )
End Function

Function UpdateOptionSetupWindow()
	If OptionSetup\Back\Clicked Then
		HideOptionSetupWindow()
		
		CreateMainMenuWindow()
		
		ChangeState( STATE_MAIN_MENU )
		
		Return
	ElseIf OptionSetup\FullScreen\Clicked Then
		Config\FullScreen = OptionSetup\FullScreen\Pressed
		
		InitGraphics()
		CreateOptionSetupWindow()
	ElseIf OptionSetup\GraphicsMode\Clicked And ( Not OptionSetup\GraphicsMode\Pressed ) Then
		Local Entry = ComboboxMarkedEntryIndex( OptionSetup\GraphicsMode )
		
		For I = 1 To CountGfxModes()
			If GfxModeDepth( I ) = 32 Then Entry = Entry - 1
			
			If Not Entry Then
				Config\GWidth = GfxModeWidth( I )
				Config\GHeight = GfxModeHeight( I )
				
				Exit
			EndIf
		Next
		
		InitGraphics()
		CreateOptionSetupWindow()
	ElseIf OptionSetup\AmbientOcclusion\Clicked Then
		Config\AmbientOcclusion = OptionSetup\AmbientOcclusion\Pressed
	ElseIf OptionSetup\CursorEnabled\Clicked Then
		Config\CursorEnabled = OptionSetup\CursorEnabled\Pressed
	ElseIf OptionSetup\MapSize\Clicked And ( Not OptionSetup\MapSize\Pressed ) Then
		Entry = ComboboxMarkedEntryIndex( OptionSetup\MapSize )
		
		Config\MapWidth = 64 Shl Entry
		Config\MapHeight = 8 Shl Entry
		Config\MapDepth = 64 Shl Entry
		
		If Config\MapHeight < 32 Then Config\MapHeight = 32
	ElseIf OptionSetup\VisibilityRange\Clicked And ( Not OptionSetup\VisibilityRange\Pressed ) Then
		Entry = ComboboxMarkedEntryIndex( OptionSetup\VisibilityRange )
		
		If Entry = 1 Then Config\ViewRange = 30
		If Entry = 2 Then Config\ViewRange = 50
		If Entry = 3 Then Config\ViewRange = 100
		If Entry = 4 Then Config\ViewRange = 150
	EndIf
	
	SaveConfig( Config )
End Function

Function HideOptionSetupWindow()
	OptionSetup\Window\Visible = False
End Function

Function CreatePlayerListWindow()
	If PlayerList\Window <> Null Then
		PlayerList\Window\Visible = True
		PlayerList\Window\Active  = True
		
		Return
	EndIf
	
	Local WindowH = Config\GHeight - 140*2
	Local WindowW = 300
	
	PlayerList\Window = CreateWindow( Config\GWidth/2 - WindowW/2, Config\GHeight/2 - WindowH/2, WindowW, WindowH, "Spielerliste", GUI_A_CENTER, GUI_W_TITLEBAR + GUI_W_LOCKED )
	
	;PlayerList\Bandwidth  = CreateLabel( PlayerList\Window,    0, 20, 280, WindowH, "", GUI_A_RIGHT )
	PlayerList\PacketLoss = CreateLabel( PlayerList\Window,  -10, 5, 280, WindowH, "", GUI_A_RIGHT )
	PlayerList\Ping       = CreateLabel( PlayerList\Window, -110, 5, 280, WindowH, "", GUI_A_RIGHT )
	PlayerList\PlayerList = CreateLabel( PlayerList\Window,   10, 5, 280, WindowH, "" )
End Function

Function UpdatePlayerListWindow()
	Local PingCaption$ = "", PlayerCaption$ = "", BandwidthCaption$ = "", PacketLossCaption$ = "", Counter
	For Player.TPlayer = Each TPlayer
		Local PacketLoss# = Floor( Player\PacketLoss#*1000.0 )*0.1
		
		PlayerCaption$     = PlayerCaption$     + Player\Name$                                   + Chr( 10 )
		PingCaption$       = PingCaption$       + Player\Ping        + "ms"                      + Chr( 10 )
		BandWidthCaption$  = BandWidthCaption$  + Player\InBandwidth + "/" + Player\OutBandwidth + Chr( 10 )
		PacketLossCaption$ = PacketLossCaption$ +        PacketLoss# + "%"                       + Chr( 10 )
	Next
	
	SetLabelCaption( PlayerList\PlayerList, PlayerCaption$ )
	SetLabelCaption( PlayerList\Ping, PingCaption$ )
	;SetLabelCaption( PlayerList\Bandwidth, BandwidthCaption$ )
	SetLabelCaption( PlayerList\PacketLoss, PacketLossCaption$ )
End Function

Function HidePlayerListWindow()
	If PlayerList\Window <> Null Then PlayerList\Window\Visible = False
End Function

Function Itembox_DropItem( ItemBank )
End Function

Function Itembox_MoveItem( ItemBank, Source.TItemBox, Dest.TItembox )
End Function

Function SingleUIRender()
	Cls
	Cls3D
	RenderGUI()
	RenderWorld
	Flip 0
End Function