;------------------------------------------------------ Netzwerk - Funktionen --------------------------------------------------------
Const NETMSG_CONNECT      = 1
Const NETMSG_KEYHIT       = 2
Const NETMSG_POSITION     = 3 
Const NETMSG_MODIFY_BLOCK = 4
Const NETMSG_KICK         = 5
Const NETMSG_DISCONNECT   = 6
Const NETMSG_CHAT         = 7
Const NETMSG_START_GAME   = 8
Const NETMSG_RESPOND_PING = 9
Const NETMSG_PING_LIST    = 10
Const NETMSG_GENERATE_MAP = 11
Const NETMSG_GODMODE      = 12
Const NETMSG_DONE_GENERATING = 13
Const NETMSG_MAPDATA      = 14
Const NETMSG_MAPHEADER    = 15
Const NETMSG_INTERACTION  = 16
Const NETMSG_CROUCHING    = 17
Const NETMSG_DENIED       = 18
Const NETMSG_LOGIN        = 19

Const NETWORK_POSITION_DELAY = 200
Const NETWORK_PING_DELAY     = 500

Const SERVER_PEER_ID = -42

Const SERVER_PORT = 16000

Global NetworkTimer = MilliSecs()
Global MapCreationSeed = MilliSecs()
Global CompressedMapBank, MapPacketCount
Global ServerIP$

Global PingDelayTimer = MilliSecs()

Global NetworkEnabled = True

Global IsHost

Function InitNetwork()
	If Not NetworkEnabled Then Return
	
	ENetInitialize()
	
	If IsHost Then
		ENetCreate( True, "any", SERVER_PORT, 10, 0, 0 )
	Else
		ENetCreate( False, "", 0, 0, 0, 0 )
	EndIf
End Function

Function ServerMailBox()
	If Not NetworkEnabled Then Return
	
	While ENetDoEventCheck( 0 ) > 0
		EventType = ENetCheckEvents( PeerID, Packetlength, DataBank )
		
		Select EventType
			Case ENET_EVENT_TYPE_RECEIVE
				MsgType = ReadByteEx()
				
				Select MsgType
					Case NETMSG_CONNECT
						Player.TPlayer = New TPlayer
							Player\Name$ = ReadStringEx()
							Player\PeerID = PeekInt( PeerID, 0 )
						
						Local Version = ReadIntEx()
						
						If Version <> NOOCRAFT_VERSION Then
							WriteByteEx( NETMSG_DENIED )
							WriteStringEx( "Inkompatible Version. Untersttzte Version ist " + VERSION_STRING + "." )
							
							ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
							
							Delete Player
							
							Goto Continue
						EndIf
													
						AddPlayer( Player )
						
						Counter = 0
						For CurrPlayer.TPlayer = Each TPlayer
							If CurrPlayer <> LocalPlayer Then
								If CurrPlayer = Last TPlayer Then Exit
								
								WriteByteEx( NETMSG_CONNECT )
								WriteIntEx( MapCreationSeed )
								WriteIntEx( CurrPlayer\PeerID )
								WriteByteEx( 1 )
								WriteStringEx( Player\Name$ )
								WriteIntEx( Player\PeerID )
								WriteIntEx( Player\GodMode )
								WriteIntEx( Player\Crouching )
								
								ENetSendData( ENetMsg$, Len( ENetMsg$ ), CurrPlayer\PeerID, True )
								ENetMsg$ = ""
							EndIf
							
							Counter = Counter + 1
						Next
						
						WriteByteEx( NETMSG_CONNECT )
						WriteIntEx( MapCreationSeed )
						WriteIntEx( Player\PeerID )
						WriteByteEx( Counter )
						For CurrPlayer.TPlayer = Each TPlayer
							If CurrPlayer = Last TPlayer Then Exit
							
							WriteStringEx( CurrPlayer\Name$ )
							WriteIntEx( CurrPlayer\PeerID )
							WriteIntEx( CurrPlayer\GodMode )
							WriteIntEx( CurrPlayer\Crouching )
						Next
						
						ENetSendData( ENetMsg$, Len( ENetMsg$ ), PeekInt( PeerID, 0 ), True )
						ENetMsg$ = ""
					Case NETMSG_KEYHIT
						Peer = PeekInt( PeerID, 0 )
						ReadIntEx()
						Input = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\Input = Input
								
								Exit
							EndIf
						Next
						
						WriteByteEx( NETMSG_KEYHIT )
						WriteIntEx( Peer )
						WriteIntEx( Input )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
					Case NETMSG_POSITION
						Peer = PeekInt( PeerID, 0 )
						ReadIntEx()
						PlayerX# = ReadFloatEx()
						PlayerY# = ReadFloatEx()
						PlayerZ# = ReadFloatEx()
						RotX# = ReadFloatEx()
						RotY# = ReadFloatEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\X# = PlayerX#
								Player\Y# = PlayerY#
								Player\Z# = PlayerZ#
								Player\RotX# = RotX#
								Player\RotY# = RotY#
							EndIf
						Next
						
						WriteByteEx( NETMSG_POSITION )
						WriteIntEx( Peer )
						WriteFloatEx( PlayerX# )
						WriteFloatEx( PlayerY# )
						WriteFloatEx( PlayerZ# )
						WriteFloatEx( RotX# )
						WriteFloatEx( RotY# )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
					Case NETMSG_MODIFY_BLOCK
						Peer = PeekInt( PeerID, 0 )
						VoxelX = ReadIntEx()
						VoxelY = ReadIntEx()
						VoxelZ = ReadIntEx()
						NX# = ReadFloatEx()
						NY# = ReadFloatEx()
						NZ# = ReadFloatEx()
						NewBlock = ReadIntEx()
						
						WriteByteEx( NETMSG_MODIFY_BLOCK )
						WriteIntEx( VoxelX )
						WriteIntEx( VoxelY )
						WriteIntEx( VoxelZ )
						WriteFloatEx( NX# )
						WriteFloatEx( NY# )
						WriteFloatEx( NZ# )
						WriteIntEx( NewBlock )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
						
						If Not NewBlock Then
							RemoveBlock( VoxelX, VoxelY, VoxelZ )
						Else
							AddBlock( VoxelX, VoxelY, VoxelZ, NX#, NY#, NZ#, NewBlock, True )
						EndIf
					Case NETMSG_CHAT
						Peer = PeekInt( PeerID, 0 )
						Message$ = ReadStringEx()
						
						WriteByteEx( NETMSG_CHAT )
						WriteStringEx( Message$ )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
						
						AddChat( Message$ )
					Case NETMSG_RESPOND_PING
						Peer = PeekInt( PeerID, 0 )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\Ping = MilliSecs() - Player\PingTimer
								
								Player\PingTimer = 0
								
								Exit
							EndIf
						Next
					Case NETMSG_DONE_GENERATING
						Peer = PeekInt( PeerID, 0 )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\DoneGenerating = True
							EndIf
						Next
					Case NETMSG_GODMODE
						Peer = PeekInt( PeerID, 0 )
						ReadIntEx()
						Mode = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\GodMode = Mode
								
								Exit
							EndIf
						Next
						
						WriteByteEx( NETMSG_GODMODE )
						WriteIntEx( Peer )
						WriteIntEx( Mode )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
					Case NETMSG_CROUCHING
						Peer = PeekInt( PeerID, 0 )
						ReadIntEx()
						Mode = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								SetCrouchModeForPlayer( Player, Mode )
								
								Exit
							EndIf
						Next
						
						WriteByteEx( NETMSG_CROUCHING )
						WriteIntEx( Peer )
						WriteIntEx( Mode )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
					Case NETMSG_INTERACTION
						Peer = PeekInt( PeerID, 0 )
						VoxelX = ReadIntEx()
						VoxelY = ReadIntEx()
						VoxelZ = ReadIntEx()
						
						WriteByteEx( NETMSG_INTERACTION )
						WriteIntEx( VoxelX )
						WriteIntEx( VoxelY )
						WriteIntEx( VoxelZ )
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID <> Peer And Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
						Next
						ENetMsg$ = ""
						
						TriggerGameObject( MapGOs( VoxelX, VoxelY, VoxelZ ) )
				End Select
			Case ENET_EVENT_TYPE_DISCONNECT
				Peer = PeekInt( PeerID, 0 )
				
				WriteByteEx( NETMSG_DISCONNECT )
				WriteIntEx( Peer )
				
				For Player.TPlayer = Each TPlayer
					If Player\PeerID = Peer Then
						DisconnectPlayer( Player )
					Else
						If Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
					EndIf
				Next
				ENetMsg$ = ""
		End Select
		
		.Continue
		
		ENetOffset = 0
	Wend
	
	If MilliSecs() - PingDelayTimer > NETWORK_PING_DELAY Then
		WriteByteEx NETMSG_PING_LIST
		For Player.TPlayer = Each TPlayer
			WriteIntEx Player\PeerID
			WriteIntEx Player\Ping
			WriteIntEx 0
			WriteIntEx 0
			WriteFloatEx 0.0
		Next
		
		For Player.TPlayer = Each TPlayer
			If Player <> LocalPlayer And ( Not Player\PingTimer ) Then
				ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
			
				Player\PingTimer = MilliSecs()
			EndIf
		Next
		ENetMsg$ = ""
		
		PingDelayTimer = MilliSecs()
	EndIf
End Function

Function ClientMailBox()
	If Not NetworkEnabled Then Return
	While ENetDoEventCheck( 0 ) > 0
		EventType = ENetCheckEvents( PeerID, Packetlength, DataBank )
		
		Select EventType
			Case ENET_EVENT_TYPE_DISCONNECT
				RuntimeError "Verbindung wurde unterbrochen!"
			Case ENET_EVENT_TYPE_RECEIVE
				MsgType = ReadByteEx()
				
				Select MsgType
					Case NETMSG_CONNECT
						MapCreationSeed = ReadIntEx()
						LocalPlayer\PeerID = ReadIntEx()
						PlayerCount = ReadByteEx()
						
						For i = 1 To PlayerCount
							Player.TPlayer = New TPlayer
								Player\Name$ = ReadStringEx()
								Player\PeerID = ReadIntEx()
								Player\GodMode = ReadIntEx()
								Player\Crouching = ReadIntEx()
							
							AddPlayer( Player )
							
							SetCrouchModeForPlayer( Player, Player\Crouching )
						Next
					Case NETMSG_DISCONNECT
						Peer = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								DisconnectPlayer( Player )
							EndIf
						Next
					Case NETMSG_KICK
						Peer = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								KickPlayer( Player )
							EndIf
						Next
					Case NETMSG_CHAT
						Message$ = ReadStringEx()
						
						AddChat( Message$ )
					Case NETMSG_KEYHIT
						Peer = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer Then
								Player\Input = ReadIntEx()
								
								Exit
							EndIf
						Next
					Case NETMSG_POSITION
						Peer = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer And Player <> LocalPlayer Then
								Player\X# = ReadFloatEx()
								Player\Y# = ReadFloatEx()
								Player\Z# = ReadFloatEx()
								Player\RotX# = ReadFloatEx()
								Player\RotY# = ReadFloatEx()
								
								Exit
							EndIf
						Next
					Case NETMSG_MODIFY_BLOCK
						VoxelX = ReadIntEx()
						VoxelY = ReadIntEx()
						VoxelZ = ReadIntEx()
						NX# = ReadFloatEx()
						NY# = ReadFloatEx()
						NZ# = ReadFloatEx()
						NewBlock = ReadIntEx()
						
						If Not NewBlock Then
							RemoveBlock( VoxelX, VoxelY, VoxelZ )
						Else
							AddBlock( VoxelX, VoxelY, VoxelZ, NX#, NY#, NZ#, NewBlock, True )
						EndIf
					Case NETMSG_START_GAME
						StartMultiplayer()
						
						ChangeState( STATE_GAME_MULTI )
						
						HideGenerateMapWindow()
					Case NETMSG_GENERATE_MAP
						MapW = ReadIntEx()
						MapH = ReadIntEx()
						MapD = ReadIntEx()
						
						ChangeState( STATE_GENERATE_MAP )
						
						HideLobbyWindow()
						CreateGenerateMapWindow()
						
						SingleUIRender()
						
						GenerateMap()
					Case NETMSG_PING_LIST
						For PlayerIterator.TPlayer = Each TPlayer
							Peer = ReadIntEx()
							Ping = ReadIntEx()
							Inbandwidth = ReadIntEx()
							Outbandwidth = ReadIntEx()
							PacketLoss# = ReadFloatEx()
							
							For Player.TPlayer = Each TPlayer
								If Player\PeerID = Peer Then
									Player\Ping = Ping
									Player\Inbandwidth = Inbandwidth
									Player\Outbandwidth = Outbandwidth
									Player\PacketLoss# = PacketLoss#
									
									Exit
								EndIf
							Next
						Next
						
						WriteByteEx NETMSG_RESPOND_PING
						SendMessage()
					Case NETMSG_GODMODE
						Peer = ReadIntEx()
						Mode = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer And Player <> LocalPlayer Then
								Player\GodMode = Mode
								
								Exit
							EndIf
						Next
					Case NETMSG_CROUCHING
						Peer = ReadIntEx()
						Mode = ReadIntEx()
						
						For Player.TPlayer = Each TPlayer
							If Player\PeerID = Peer And Player <> LocalPlayer Then
								SetCrouchModeForPlayer( Player, Mode )
								
								Exit
							EndIf
						Next
					Case NETMSG_MAPDATA
						LocalPlayer\LoggedIn = False ;TODO
						
						MapW = ReadIntEx()
						MapH = ReadIntEx()
						MapD = ReadIntEx()
						
						Local Password = ReadIntEx()
						
						ChangeState( STATE_GENERATE_MAP )
						
						HideLobbyWindow()
						CreateGenerateMapWindow()
						
						SingleUIRender()
						
						Local Instream = OpenTCPStream( ServerIP$, SERVER_PORT )
						
						If Not Instream Then RuntimeError( "Verbindung getrennt!" )
						
						MapSize  = ReadInt( Instream )
						
						Local CompressedMapBank = CreateBank( MapSize )
						
						TCPTimeouts 10000, 0
						Local BytesRead
						While BytesRead < MapSize
							If Eof( Instream ) <> 0 Then RuntimeError( "Verbindung getrennt!" )
							
							Local Avail = ReadAvail( Instream )
							If Avail Then
								Local BytesToRead = Avail
								
								If MapSize - BytesToRead - BytesRead < 0 Then BytesToRead = MapSize - BytesRead
								
								ReadBytes( CompressedMapBank, Instream, BytesRead, BytesToRead )
								
								BytesRead = BytesRead + Avail
								
								DebugLog "Avail: " + Avail + " Received " + ( 100.0*BytesRead/Float( MapSize ) ) + "%"
							EndIf
							
							ENetDoEventCheck( 0 )
						Wend
						
						Local NormalCount = ReadInt( Instream )
						If NormalCount Then
							Local NormalBank = CreateBank( NormalCount*24 )
							
							For I = 0 To BankSize( NormalBank ) - 1 Step 10
								ReadSize = BankSize( NormalBank ) - I
								
								If ReadSize > 10 Then ReadSize = 10
								
								ReadBytes( NormalBank, Instream, I, ReadSize )
							Next
						EndIf
						
						CloseTCPStream( Instream )
						
						Local DestinationBank = CreateBank( MapW*MapH*MapD )
						Local DestinationSize  = CreateBank( 4 )
						
						PokeInt DestinationSize, 0, BankSize( DestinationBank )
						
						ZlibWapi_UnCompress( DestinationBank, DestinationSize, CompressedMapBank, BankSize( CompressedMapBank ) )
						
						InitMap( True )
						FillMapFromBank( DestinationBank, NormalBank )
						
						FreeBank DestinationBank
						FreeBank CompressedMapBank
						FreeBank NormalBank
						
						HideGenerateMapWindow()
						
						ChangeState( STATE_GAME_MULTI )
						
						StartMultiplayer()
					Case NETMSG_INTERACTION
						VoxelX = ReadIntEx()
						VoxelY = ReadIntEx()
						VoxelZ = ReadIntEx()
						
						TriggerGameObject( MapGOs( VoxelX, VoxelY, VoxelZ ) )
					Case NETMSG_DENIED
						RuntimeError ReadStringEx()
					Case NETMSG_LOGIN
						LocalPlayer\LoggedIn = True
				End Select
		End Select
		
		ENetOffset = 0
	Wend
End Function

Function NetworkSendKeyhit()
	If Not USE_STEALTH_MODE Then
		WriteByteEx( NETMSG_KEYHIT )
		WriteIntEx( LocalPlayer\PeerID )
		WriteIntEx( LocalPlayer\Input )
		
		SendMessage()
	EndIf
End Function

Function NetworkSendChat( Message$ )
	WriteByteEx( NETMSG_CHAT )
	WriteStringEx( Message$ )
	
	SendMessage()
End Function

Function NetworkSendStartGame()
	WriteByteEx( NETMSG_START_GAME )
	
	SendMessage()
End Function

Function NetworkSendPlayerKick( Player.TPlayer )
	WriteByteEx( NETMSG_KICK )
	WriteIntEx( Player\PeerID )
	
	SendMessage()
End Function

Function NetworkSendPosition()
	If Not USE_STEALTH_MODE Then
		WriteByteEx( NETMSG_POSITION )
		WriteIntEx( LocalPlayer\PeerID )
		WriteFloatEx( LocalPlayer\X# )
		WriteFloatEx( LocalPlayer\Y# )
		WriteFloatEx( LocalPlayer\Z# )
		WriteFloatEx( LocalPlayer\RotX# )
		WriteFloatEx( LocalPlayer\RotY# )
		
		SendMessage()
	EndIf
End Function

Function NetworkSendModifyBlock( VoxelX, VoxelY, VoxelZ, NX#, NY#, NZ#, NewBlock )
	WriteByteEx( NETMSG_MODIFY_BLOCK )
	WriteIntEx( VoxelX )
	WriteIntEx( VoxelY )
	WriteIntEx( VoxelZ )
	WriteFloatEx( NX# )
	WriteFloatEx( NY# )
	WriteFloatEx( NZ# )
	WriteIntEx( NewBlock )
	
	SendMessage()
End Function

Function NetworkSendDoneGenerating()
	WriteByteEx( NETMSG_DONE_GENERATING )
	
	SendMessage()
End Function

Function NetworkSendGenerateMap()
	WriteByteEx( NETMSG_GENERATE_MAP )
	WriteIntEx( MapW )
	WriteIntEx( MapH )
	WriteIntEx( MapD )
	
	SendMessage()
End Function

Function NetworkSendGodmode( Mode )
	If Not USE_STEALTH_MODE Then
		WriteByteEx( NETMSG_GODMODE )
		WriteIntEx( LocalPlayer\PeerID )
		WriteIntEx( Mode )
		
		SendMessage()
	EndIf
End Function

Function NetworkSendCrouching( Mode )
	If Not USE_STEALTH_MODE Then
		WriteByteEx( NETMSG_CROUCHING )
		WriteIntEx( LocalPlayer\PeerID )
		WriteIntEx( Mode )
		
		SendMessage()
	EndIf
End Function

Function NetworkSendInteraction( VoxelX, VoxelY, VoxelZ )
	WriteByteEx( NETMSG_INTERACTION )
	WriteIntEx( VoxelX )
	WriteIntEx( VoxelY )
	WriteIntEx( VoxelZ )
	
	SendMessage()
End Function

Function ClientConnect( IP$ )
	If ENetConnect( IP$, SERVER_PORT ) = -1 Then RuntimeError( "Konnte nicht zum Server verbinden" )
	
	ServerIP$ = IP$
	
	WriteByteEx( NETMSG_CONNECT )
	WriteStringEx( LocalPlayer\Name$ )
	WriteIntEx( NOOCRAFT_VERSION )
	SendMessage()
End Function

Function GeneratePlayerPositions()
	For CurrPlayer.TPlayer = Each TPlayer
		CurrPlayer\X# = Rand( MapW/4.0, 3.0*MapW/4.0 )
		CurrPlayer\Z# = Rand( MapD/4.0, 3.0*MapD/4.0 )
		CurrPlayer\Y# = MapHeight( CurrPlayer\X#, CurrPlayer\Z# ) + 3
		
		If CurrPlayer <> LocalPlayer Then
			WriteByteEx( NETMSG_POSITION )
			WriteFloatEx( CurrPlayer\X# )
			WriteFloatEx( CurrPlayer\Y# )
			WriteFloatEx( CurrPlayer\Z# )
			WriteFloatEx( CurrPlayer\RotX# )
			WriteFloatEx( CurrPlayer\RotY# )
			
			SendMessage()
		EndIf
	Next
End Function

Function SendMessage()
	If NetworkEnabled Then
		If IsHost Then
			For Player.TPlayer = Each TPlayer
				If Player <> LocalPlayer Then ENetSendData( ENetMsg$, Len( ENetMsg$ ), Player\PeerID, True )
			Next
		Else
			ENetSendData( ENetMsg$, Len( ENetMsg$ ) - 1, 0, True )
		EndIf
	EndIf
	
	ENetMsg$ = ""
End Function