Global Config.TConfig, CurrentState

Const DEVELOPMENT_MODE = False
Const USE_STEALTH_MODE = False

Const NOOCRAFT_VERSION = $000206
Const VERSION_STRING$  = "0.2.6"

Include "Config.bb"
Include "DX7Hack.bb"
Include "ENetInclude.bb"
Include "Map.bb"
Include "Lua_Include.bb"
Include "Lua.bb"
Include "Player.bb"
Include "Util.bb"
Include "Network.bb"
Include "Minimap.bb"
Include "HUD.bb"
Include "Particle.bb"
Include "GUI\Noo3D.bb"
Include "GUI\GUI.bb"
Include "Gui Util.bb"

;TODO:

;Trees
;Tastenbelegung
;Mehr Achterbahnteile (zufllige Weichen etc.)
;Gamma
;Blickrichtung in Pfeilrichtung

Const STATE_MAIN_MENU     = 1
Const STATE_CLIENT_SERVER = 2
Const STATE_LOBBY         = 3
Const STATE_GAME_SINGLE   = 4
Const STATE_GAME_MULTI    = 5
Const STATE_GENERATE_MAP  = 6
Const STATE_OPTIONS       = 7

Init()

Local Timer = CreateTimer( 60 )

While Not KeyHit( 1 )
	;If GraphicsLost() Then InitGraphics()
	
	UpdateInput()
	
	Select CurrentState
		Case STATE_GAME_SINGLE
			Render3DCursor()
		Case STATE_GAME_MULTI
			Render3DCursor()
			RenderPlayerNames()
	End Select
	
	UpdateGUI()
	RenderGUI()
	
	DrawCursor()
	
	RenderWorld
	
	Select CurrentState
		Case STATE_GAME_SINGLE
			DrawHUD()
			
			UserInput()
			UpdateScheduledBlocks()
			UpdateMap()
			ContinuousMapSave()
			IncrementalMinimapRender()
			
			UpdatePlayers()
			UpdateParticles()
		Case STATE_GAME_MULTI
			DrawHUD()
			
			If Not UIActive Then UserInput()
			
			If IsHost Then
				ServerMailBox()
			Else
				ClientMailBox()
			EndIf
			
			UpdateScheduledBlocks()
			UpdateMap()
			ContinuousMapSave()
			IncrementalMinimapRender()
			
			UpdatePlayers()
			UpdateParticles()
			UpdateIngameChatWindow()
			UpdatePlayerListWindow()
		Case STATE_GENERATE_MAP
			If IsHost Then
				ServerMailBox()
			Else
				ClientMailBox()
			EndIf
			
			UpdateGenerateMapWindow()
		Case STATE_LOBBY
			If IsHost Then
				ServerMailBox()
			Else
				ClientMailBox()
			EndIf
			
			UpdateLobbyWindow()
		Case STATE_CLIENT_SERVER
			UpdateClientServerWindow()
		Case STATE_MAIN_MENU
			UpdateMainMenuWindow()
		Case STATE_OPTIONS
			UpdateOptionSetupWindow()
	End Select
	
	Flip 0
	Cls3D
	Cls
	WaitTimer Timer
Wend
QuitGame()

Function UpdateInput()
	MX = MouseX()
	MY = MouseY()
	MH1 = MouseHit( 1 )
	MH2 = MouseHit( 2 )
	MH3 = MouseHit( 3 )
	MD1 = MouseDown( 1 )
	MD2 = MouseDown( 2 )
	MD3 = MouseDown( 3 )
End Function

Function Init()
	Config = LoadConfig()
	
	InitLua()
	
	InitGraphics( True )
	
	CreateMainMenuWindow()
	
	ChangeState( STATE_MAIN_MENU )
End Function

Function InitGraphics( LoadLua = False )
	EndGraphics
	Graphics3D Config\GWidth, Config\GHeight, 0, 2 - ( Config\FullScreen <> 0 )
	SetBuffer BackBuffer()
	
	;InitDX7Hack()
	;DisableTextureFilters()
	
	AppTitle "Noocraft"
	
	MapLight = CreateLight()
	AlignToVector MapLight, -1.0, -1.5, -0.5, 3
	LightColor MapLight, 128, 128, 64
	AmbientLight 160, 160, 140
	
	LoadMapTextures()
	If LoadLua Then LoadBlocks()
	InitGUI()
	PreRenderBlocks()
	LoadCursor()
	
	Skybox = MakeSkybox( "Models\Skybox\Sky" )
End Function

Function QuitGame()
	ENetDeInitialize()
	
	End
End Function

Function StartSingleplayer()
	HideMainMenuWindow()
	CreateGenerateMapWindow()
	
	SingleUIRender()
	
	GenerateMap()
	PreRenderMinimap()
	
	HideGenerateMapWindow()
	
	NetworkEnabled = False
	
	InitPlayer( "", False )
	InitPlayer3D()
	CameraProjMode LocalPlayer\Camera, 1
	
	InitDX7Hack()
	DisableTextureFilters()
	
	MoveMouse Config\GWidth/2, Config\GHeight/2
	MouseXSpeed()
	MouseYSpeed()
End Function

Function StartMultiplayer()
	PreRenderMinimap()
	
	InitPlayer3D()
	
	CreateIngameChatWindow()
	CreatePlayerListWindow()
	
	AddChat( "Welcome to Noocraft! Press enter to chat with other players" )
	
	MoveMouse Config\GWidth/2, Config\GHeight/2
	MouseXSpeed()
	MouseYSpeed()
	
	CameraProjMode LocalPlayer\Camera, 1
	
	InitDX7Hack()
	DisableTextureFilters()
End Function

Function ChangeState( NewState )
	CurrentState = NewState
End Function