Global ParticleMesh, ParticleSurf

Type TParticle
	Field X#
	Field Y#
	Field Z#
	
	Field VX#
	Field VY#
	Field VZ#
	
	Field U1#
	Field V1#
	Field U2#
	Field V2#
	
	Field Size#
	
	Field Lifetimer
	
	Field Index
End Type

Function InitParticles( Parent, Texture )
	ParticleMesh = CreateMesh()
	ParticleSurf = CreateSurface( ParticleMesh )
	
	EntityParent ParticleMesh, Parent
	EntityFX ParticleMesh, 1
	EntityTexture ParticleMesh, Texture
End Function

Function CreateParticle( X#, Y#, Z#, VX#, VY#, VZ#, U1#, V1#, U2#, V2#, Lifetime, Size# )
	Local Particle.TParticle = New TParticle
	
	Particle\X# = X#
	Particle\Y# = Y#
	Particle\Z# = Z#
	Particle\VX# = VX#
	Particle\VY# = VY#
	Particle\VZ# = VZ#
	Particle\U1# = U1#
	Particle\U2# = U2#
	Particle\V1# = V1#
	Particle\V2# = V2#
	Particle\Lifetimer = MilliSecs() + Lifetime
	Particle\Size# = Size#
	
	Local LastParticle.TParticle = Before Last TParticle
	Local Index = -4
	
	If LastParticle <> Null Then Index = LastParticle\Index
	
	Particle\Index = Index + 4
	
	If Particle\Index + 4 > CountVertices( ParticleSurf ) Then
		For I = CountVertices( ParticleSurf ) To Particle\Index + 3
			AddVertex ParticleSurf, -5000, -5000, -5000
		Next
		
		AddTriangle ParticleSurf, Particle\Index + 0, Particle\Index + 1, Particle\Index + 2
		AddTriangle ParticleSurf, Particle\Index + 0, Particle\Index + 2, Particle\Index + 3
	EndIf
End Function

Function UpdateParticles()
	Local VertexSubstract
	For Particle.TParticle = Each TParticle
		If MilliSecs() > Particle\Lifetimer Then
			Particle\X# = -5000
			Particle\Y# = -5000
			Particle\Z# = -5000
			
			VertexSubstract = VertexSubstract + 4
		Else
			If VertexSubstract > 0 Then
				For I = 0 To 3
					VertexCoords ParticleSurf, Particle\Index + I, -5000, -5000, -5000
				Next
				
				Particle\Index = Particle\Index - VertexSubstract
			EndIf
		EndIf
		
		TFormPoint Particle\X#, Particle\Y#, Particle\Z#, 0, ParticleMesh
		
		VertexCoords ParticleSurf, Particle\Index    , TFormedX() - Particle\Size#, TFormedY() + Particle\Size#, TFormedZ()
		VertexCoords ParticleSurf, Particle\Index + 1, TFormedX() + Particle\Size#, TFormedY() + Particle\Size#, TFormedZ()
		VertexCoords ParticleSurf, Particle\Index + 2, TFormedX() + Particle\Size#, TFormedY() - Particle\Size#, TFormedZ()
		VertexCoords ParticleSurf, Particle\Index + 3, TFormedX() - Particle\Size#, TFormedY() - Particle\Size#, TFormedZ()
		VertexTexCoords ParticleSurf, Particle\Index + 0, Particle\U1#, Particle\V1#
		VertexTexCoords ParticleSurf, Particle\Index + 1, Particle\U2#, Particle\V1#
		VertexTexCoords ParticleSurf, Particle\Index + 2, Particle\U2#, Particle\V2#
		VertexTexCoords ParticleSurf, Particle\Index + 3, Particle\U1#, Particle\V2#
		
		Local BlockType = SaveAccess( Particle\X# + Particle\VX#, Particle\Y# + Particle\VY#, Particle\Z# + Particle\VZ# )
		If BlockType = -1 Then BlockType = 0
		
		If Not BlockTypes[ BlockType ]\IsSolidBlock Then
			Particle\X# = Particle\X# + Particle\VX#
			Particle\Y# = Particle\Y# + Particle\VY#
			Particle\Z# = Particle\Z# + Particle\VZ#
			Particle\VY# = Particle\VY# - GRAVITY#
		EndIf
		
		If MilliSecs() > Particle\Lifetimer Then Delete Particle
	Next
End Function