Const MOVE_SPEED# = 0.05
Const MAX_SPEED# = 0.5
Const GRAVITY# = 0.01

Const INPUT_LEFT   = %00000001
Const INPUT_RIGHT  = %00000010
Const INPUT_UP     = %00000100
Const INPUT_DOWN   = %00001000
Const INPUT_JUMP   = %00010000
Const INPUT_RISE   = %00100000
Const INPUT_SPRINT = %01000000

Const FAST_BLOCK_DELAY = 100

Const MAX_BLOCK_DISTANCE# = 20.0

Global LocalPlayer.TPlayer

Global DeltaTimer = MilliSecs(), FastBlockTimer = MilliSecs()

Type TPlayer
	Field Camera
	Field Entity
	
	Field LoggedIn
	
	Field Name$
	Field PeerID
	
	Field Ping
	Field PingTimer
	
	Field Inbandwidth
	Field Outbandwidth
	Field PacketLoss#
	
	Field DoneGenerating
	
	Field X#
	Field Y#
	Field Z#
	
	Field VX#
	Field VY#
	Field VZ#
	
	Field RotX#
	Field RotY#
	Field RotVX#
	Field RotVY#
	Field OldBlock
	
	Field Input
	Field Godmode
	Field Crouching
	Field TouchBottom
End Type

Function InitPlayer( Name$, Host )
	LocalPlayer = New TPlayer
	
	LocalPlayer\PeerID = SERVER_PEER_ID
	LocalPlayer\Name$ = Name$
	LocalPlayer\LoggedIn = True
	
	IsHost = Host
End Function

Function InitPlayer3D()
	LocalPlayer\Entity = CreatePivot()
	LocalPlayer\Camera = CreateCamera( LocalPlayer\Entity )
	MoveEntity LocalPlayer\Camera, 0.0, 0.4, 0.0
	
	CameraClsMode LocalPlayer\Camera, False, True
	CameraProjMode LocalPlayer\Camera, 0
	
	LocalPlayer\X# = MapW/5.0 ;Rand( MapW/4.0, 3.0*MapW/4.0 )
	LocalPlayer\Z# = MapD/3.5 ;Rand( MapD/4.0, 3.0*MapD/4.0 )
	LocalPlayer\Y# = MapHeight( LocalPlayer\X#, LocalPlayer\Z# )
	
	EntityType LocalPlayer\Entity, COLLISION_TYPE_PLAYER
	EntityRadius LocalPlayer\Entity, 0.3, 0.9
	
	Collisions COLLISION_TYPE_PLAYER, COLLISION_TYPE_LEVEL, 2, 2
	
	PositionEntity LocalPlayer\Entity, LocalPlayer\X#, LocalPlayer\Y#, LocalPLayer\Z#
	
	UpdateWorld()
	
	LocalPlayer\Y# = LocalPlayer\Y# + 10
	MoveEntity LocalPlayer\Entity, 0.0, 10.0, 0.0
	
	InitParticles( LocalPlayer\Entity, BlockTextureAlpha )
End Function

Function AddPlayer( Player.TPlayer )
	Player\Entity = CreateCube()
	PositionEntity Player\Entity, Player\X#, Player\Y#, Player\Z#
	
	UpdateWorld()
	
	ScaleMesh Player\Entity, 0.3, 0.9, 0.3
	EntityType Player\Entity, COLLISION_TYPE_PLAYER
	EntityRadius Player\Entity, 0.3, 0.9
	
	If CurrentState = STATE_GAME_MULTI Then AddChat( "Player " + Player\Name$ + " joined the game" )
End Function

Function UserInput()
	Local MXS# = Float( MouseXSpeed() )
	Local MYS# = Float( MouseYSpeed() )
	
	If Not MainWindowActive() Then
		MXS# = 0.0
		MYS# = 0.0
	EndIf
	
	LocalPlayer\RotVX# = ( LocalPlayer\RotVX#*Config\MouseSensitivity# + MYS# )/( Config\MouseSensitivity# + 1.0 )
	LocalPlayer\RotVY# = ( LocalPlayer\RotVY#*Config\MouseSensitivity# - MXS# )/( Config\MouseSensitivity# + 1.0 )
	LocalPlayer\RotX# = LocalPlayer\RotX# + LocalPlayer\RotVX#
	LocalPlayer\RotY# = LocalPlayer\RotY# + LocalPlayer\RotVY#
	If ( Not DEVELOPMENT_MODE ) And MainWindowActive() Then MoveMouse Config\GWidth/2, Config\GHeight/2
	
	If Abs( LocalPlayer\RotX# ) > 85.0 Then LocalPlayer\RotX# = Sgn( LocalPlayer\RotX# )*85.0
	
	Local OldInput = LocalPlayer\Input
	LocalPlayer\Input = 0
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 32 ) )*INPUT_RIGHT
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 30 ) )*INPUT_LEFT
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 17 ) )*INPUT_UP
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 31 ) )*INPUT_DOWN
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyHit ( 57 ) )*INPUT_JUMP
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 57 ) )*INPUT_RISE
	LocalPlayer\Input = LocalPlayer\Input Or Sgn( KeyDown( 42 ) )*INPUT_SPRINT
	
	
	Local BlocksPerScreen = Floor( Config\GWidth/Float( TEXTURE_SCREEN_SIZE ) )
	If BlocksPerScreen > BlockCounter - 1 Then BlocksPerScreen = BlockCounter - 1
	
	SelectedBlock = ( ( SelectedBlock - 1 + ( BlockCounter - 1 ) - MouseZSpeed() + ( KeyHit( 209 ) - KeyHit( 201 ) )*BlocksPerScreen ) Mod ( BlockCounter - 1 ) ) + 1
	If KeyHit( 199 ) Then SelectedBlock = 1
	If KeyHit( 207 ) Then SelectedBlock = BlockCounter - 1
	
	
	If KeyHit( 88 ) Then SaveScreenshot()
	
	Local MouseLeft   = MH1
	Local MouseRight  = MH2
	Local MouseMiddle = MH3
	Local Pipette = KeyHit( 16 )
	Local Backtrace = KeyHit( 14 )
	
	If KeyDown( 29 ) Or KeyDown( 157 ) Then
		If MouseLeft Or MouseRight Or MouseMiddle Then FastBlockTimer = MilliSecs()
		
		If MilliSecs() - FastBlockTimer > FAST_BLOCK_DELAY Then
			MouseLeft   = MH1 Or MD1
			MouseRight  = MH2 Or MD2
			MouseMiddle = MH3 Or MD3
			
			FastBlockTimer = MilliSecs()
		EndIf
	EndIf
	
	If KeyHit( 18 ) Then
		If CameraPick( LocalPlayer\Camera, MouseX(), MouseY() ) Then
			TFormPoint PickedX(), PickedY(), PickedZ(), 0, LocalPlayer\Entity
			
			;DDA( EntityX( Cam ), EntityY( Cam ), EntityZ( Cam ), TFormedX(), TFormedY(), TFormedZ() )
			
			If TFormedZ() < MAX_BLOCK_DISTANCE Then
				Local DirX# = -Sgn( PickedNX() )*0.1
				Local DirY# = -Sgn( PickedNY() )*0.1
				Local DirZ# = -Sgn( PickedNZ() )*0.1
				
				Local VoxelX = Int( PickedX() + DirX# )
				Local VoxelY = Int( PickedY() + DirY# )
				Local VoxelZ = Int( PickedZ() + DirZ# )
				
				Local BlockType = MapData( VoxelX, VoxelY, VoxelZ )
				
				If BlockTypes[ BlockType ]\IsTrigger And BlockTypes[ BlockType ]\TriggeredOnAction Then
					TriggerGameObject( MapGOs( VoxelX, VoxelY, VoxelZ ) )
					
					NetworkSendInteraction( VoxelX, VoxelY, VoxelZ )
				EndIf
			EndIf
		EndIf
	EndIf
	
	If ( MouseLeft + MouseRight + MouseMiddle + Pipette + Backtrace ) And LocalPlayer\LoggedIn Then
		If CameraPick( LocalPlayer\Camera, MouseX(), MouseY() ) Then
			TFormPoint PickedX(), PickedY(), PickedZ(), 0, LocalPlayer\Entity
			
			;DDA( EntityX( Cam ), EntityY( Cam ), EntityZ( Cam ), TFormedX(), TFormedY(), TFormedZ() )
			
			If TFormedZ() < MAX_BLOCK_DISTANCE Then
				DirX# = -Sgn( PickedNX() )*0.1
				DirY# = -Sgn( PickedNY() )*0.1
				DirZ# = -Sgn( PickedNZ() )*0.1
				
				If MouseRight Then
					VoxelX = Int( PickedX() + DirX# )
					VoxelY = Int( PickedY() + DirY# )
					VoxelZ = Int( PickedZ() + DirZ# )
					
					NetworkSendModifyBlock( VoxelX, VoxelY, VoxelZ, 0.0, 0.0, 0.0, 0 )
					RemoveBlock( VoxelX, VoxelY, VoxelZ )
				ElseIf MouseLeft Then
					VoxelX = Int( PickedX() - DirX# )
					VoxelY = Int( PickedY() - DirY# )
					VoxelZ = Int( PickedZ() - DirZ# )
					
					If AddBlock( VoxelX, VoxelY, VoxelZ, PickedNX(), PickedNY(), PickedNZ(), SelectedBlock ) Then
						NetworkSendModifyBlock( VoxelX, VoxelY, VoxelZ, PickedNX(), PickedNY(), PickedNZ(), SelectedBlock )
					EndIf
				ElseIf MouseMiddle Then
					VoxelX = Int( PickedX() + DirX# )
					VoxelY = Int( PickedY() + DirY# )
					VoxelZ = Int( PickedZ() + DirZ# )
					
					If AddBlock( VoxelX, VoxelY, VoxelZ, PickedNX(), PickedNY(), PickedNZ(), SelectedBlock, True ) Then
						NetworkSendModifyBlock( VoxelX, VoxelY, VoxelZ, PickedNX(), PickedNY(), PickedNZ(), SelectedBlock )
					EndIf
				ElseIf Pipette Then
					VoxelX = Int( PickedX() + DirX# )
					VoxelY = Int( PickedY() + DirY# )
					VoxelZ = Int( PickedZ() + DirZ# )
					
					SelectedBlock = MapData( VoxelX, VoxelY, VoxelZ )
				ElseIf Backtrace Then
					VoxelX = Int( PickedX() + DirX# )
					VoxelY = Int( PickedY() + DirY# )
					VoxelZ = Int( PickedZ() + DirZ# )
					
					AddChat( "Block coordinates: (" + VoxelX + "|" + VoxelY + "|" + VoxelZ + ")" )
				EndIf
			EndIf
		EndIf
	EndIf
	
	If OldInput <> LocalPlayer\Input Then NetworkSendKeyhit()
	
	If MilliSecs() - NetworkTimer > NETWORK_POSITION_DELAY Then
		NetworkSendPosition()
		
		NetworkTimer = MilliSecs()
	EndIf
	
	If KeyHit( 34 ) Then
		LocalPlayer\GodMode = Not LocalPlayer\GodMode
		
		NetworkSendGodmode( LocalPlayer\GodMode )
	EndIf
	
	If KeyHit( 46 ) And LocalPlayer\TouchBottom Then
		If ( Not LocalPlayer\Crouching ) Or ( Not BlockTypes[ SaveAccess( LocalPlayer\X#, LocalPlayer\Y# + 1.0, LocalPlayer\Z# ) ]\IsSolidBlock )
			SetCrouchModeForPlayer( LocalPlayer, Not LocalPlayer\Crouching )
			
			NetworkSendCrouching( LocalPlayer\Crouching )
		EndIf
	EndIf
	
	If KeyHit( 15 ) Then CreatePlayerListWindow ElseIf Not KeyDown( 15 ) Then HidePlayerListWindow()
	If KeyHit( 68 ) Then ToggleFullscreenMinimap()
	If KeyHit( 87 ) Then SaveCurrentMap()
	If ( Not NetworkEnabled ) And KeyHit( 59 ) Then
		Local File$ = BTLoadFile( "Map laden", CurrentDir() + "Maps\", "Map files|*.dat;*.png" )
		
		If FileType( File$ ) Then
			If Lower( Right( File$, 3 ) ) = "png" Then
				LoadMapFromPNG( File$ )
			ElseIf Lower( Right( File$, 3 ) ) = "dat" Then
				LoadMap( File$ )
			EndIf
		EndIf
	EndIf
End Function

Function GravityX( AxisIndex )
	If AxisIndex = 1 Then Return -1 ElseIf AxisIndex = 4 Then Return 1 Else Return 0
End Function

Function GravityY( AxisIndex )
	If AxisIndex = 0 Then Return -1 ElseIf AxisIndex = 3 Then Return 1 Else Return 0
End Function

Function GravityZ( AxisIndex )
	If AxisIndex = 2 Then Return -1 ElseIf AxisIndex = 5 Then Return 1 Else Return 0
End Function

Function SetCrouchModeForPlayer( Player.TPlayer, Mode )
	If Mode Then
		EntityRadius Player\Entity, 0.3, 0.45
		If Player <> LocalPlayer Then ScaleEntity Player\Entity, 1.0, 0.5, 1.0
	Else
		Player\VY# = Player\VY# + 0.1
		EntityRadius Player\Entity, 0.3, 0.9
		ScaleEntity Player\Entity, 1.0, 1.0, 1.0
	EndIf
	
	Player\Crouching = Mode
End Function

Function UpdatePlayers()
	Local Delta# = 60.0*( MilliSecs() - DeltaTimer )*0.001
	
	If Delta# > 5.0 Then Delta# = 5.0
	
	For Player.TPlayer = Each TPlayer
		PositionEntity Player\Entity, Player\X#, Player\Y#, Player\Z#
		
		Local BlockType = SaveAccess( EntityX( Player\Entity ), EntityY( Player\Entity ), EntityZ( Player\Entity ) )
		Local GravityDir
		
		If BlockType >= 0 Then GravityDir = BlockTypes[ BlockType ]\Gravity
		
		Local GravityFactor# = 1.0 - ( BlockType = BLOCK_WATER )
		
		
		If Player = LocalPlayer Then
			RotateEntity Player\Entity, 0.0, Player\RotY#, 0.0
			RotateEntity Player\Camera, Player\RotX#, 0.0, 0.0
		Else
			RotateEntity Player\Entity, 0.0, Player\RotY#, 0.0
		EndIf
		
		Local MoveSpeed# = MOVE_SPEED
		
		If Sgn( Player\Input And INPUT_SPRINT ) Then MoveSpeed# = MoveSpeed#*3.0
		
		VX# = ( Sgn( Player\Input And INPUT_RIGHT ) - Sgn( Player\Input And INPUT_LEFT ) )*MoveSpeed#
		VY# = ( Sgn( Player\Input And INPUT_RISE )  - 0.4                                )*MoveSpeed#*( BlockType = BLOCK_WATER )
		VZ# = ( Sgn( Player\Input And INPUT_UP )    - Sgn( Player\Input And INPUT_DOWN ) )*MoveSpeed#
		
		If Not SaveAccess( EntityX( Player\Entity ), EntityY( Player\Entity ) + ( VY# + Player\VY# )*Delta#, EntityZ( Player\Entity ) ) Then
			If BlockType = BLOCK_WATER Then Player\VY# = 15.0*GRAVITY#
		EndIf
		
		If Player\GodMode Or GravityDir = -1 Then
			If Player = LocalPlayer Then
				TFormVector VX#*Delta#, 0.0, VZ#*Delta#, Player\Camera, Player\Entity
				
				If Not IsNan( TFormedX() ) And ( Not IsNan( TFormedZ() ) ) And ( Not IsNan( TFormedY() ) ) Then
					MoveEntity Player\Entity, TFormedX(), TFormedY(), TFormedZ()
				EndIf
			Else
				TurnEntity Player\Entity, Player\RotX#, 0.0, 0.0
				MoveEntity Player\Entity, VX#*Delta#, 0.0, VZ#*Delta#
				RotateEntity Player\Entity, 0.0, Player\RotY#, 0.0
			EndIf
			
			If Player\GodMode Then
				Player\VX# = 0.0
				Player\VY# = 0.0
				Player\VZ# = 0.0
			EndIf
		Else
			TranslateEntity Player\Entity, Player\VX#*Delta#, Player\VY#*Delta#, Player\VZ#*Delta#
			MoveEntity Player\Entity, VX#*Delta#, VY#*Delta#, VZ#*Delta#
			
			;TFormVector VX#, 0.0, VZ#, Player\Entity, 0
			
			;If Not IsNan( TFormedX() ) And ( Not IsNan( TFormedZ() ) ) And ( Not IsNan( TFormedY() ) ) Then
			;	TranslateEntity Player\Entity, ( Player\VX# + TFormedX() )*Delta#, ( Player\VY# + VY# )*Delta#, ( Player\VZ# + TFormedZ() )*Delta#
			;Else
			;	TranslateEntity Player\Entity, 0, Player\VY#*Delta#, 0
			;EndIf
		EndIf
		
		UpdateWorld()
		
		Player\X# = EntityX( Player\Entity )
		Player\Y# = EntityY( Player\Entity )
		Player\Z# = EntityZ( Player\Entity )
		
		;If Player\OldBlock <> BlockType And GravityDir > 0 Then
		;	Player\RotVX# = -( Player\RotX# - VectorPitch( GravityX( GravityDir ), GravityY( GravityDir ), GravityZ( GravityDir ) ) )
		;	Player\RotVY# = -( Player\RotY# - VectorYaw  ( GravityX( GravityDir ), GravityY( GravityDir ), GravityZ( GravityDir ) ) )
		;EndIf
		
		Player\OldBlock = BlockType
		
		Player\TouchBottom = False
		If Not Player\GodMode And GravityDir <> -1 Then
			If EntityCollided( Player\Entity, COLLISION_TYPE_LEVEL ) Then
				For I = 1 To CountCollisions( Player\Entity )
					Local Normals#[ 2 ]
					Normals[ 0 ] = CollisionNY( Player\Entity, I )
					Normals[ 1 ] = CollisionNX( Player\Entity, I )
					Normals[ 2 ] = CollisionNZ( Player\Entity, I )
					
					If Normals[ 0 ]*Sgn( Player\VY# ) < -0.5 Then Player\VY# = 0.0
					If Normals[ 1 ]*Sgn( Player\VX# ) < -0.5 Then Player\VX# = 0.0
					If Normals[ 2 ]*Sgn( Player\VZ# ) < -0.5 Then Player\VZ# = 0.0
					
					If Normals[ 0 ] > 0.5 Then Player\TouchBottom = True
					
					If Player\TouchBottom And Sgn( Player\Input And INPUT_JUMP ) <> 0 Then Player\VY# = 20.0*GRAVITY#
					
					Player\VX# = Player\VX# + GravityFactor#*GRAVITY#*GravityX( GravityDir )
					Player\VY# = Player\VY# + GravityFactor#*GRAVITY#*GravityY( GravityDir )
					Player\VZ# = Player\VZ# + GravityFactor#*GRAVITY#*GravityZ( GravityDir )
				Next
				
				Player\VX# = Player\VX#*0.95
				Player\VY# = Player\VY#*0.95
				Player\VZ# = Player\VZ#*0.95
			Else
				Player\VX# = Player\VX# + GravityFactor#*GRAVITY#*GravityX( GravityDir )*Delta#
				Player\VY# = Player\VY# + GravityFactor#*GRAVITY#*GravityY( GravityDir )*Delta#
				Player\VZ# = Player\VZ# + GravityFactor#*GRAVITY#*GravityZ( GravityDir )*Delta#
				
				If BlockType = BLOCK_WATER Then
					Player\VX# = Player\VX#*0.99
					Player\VY# = Player\VY#*0.99
					Player\VZ# = Player\VZ#*0.99
				EndIf
			EndIf
		EndIf
		
		If Abs( Player\VX# ) > MAX_SPEED# Then Player\VX# = Sgn( Player\VX# )*MAX_SPEED#
		If Abs( Player\VY# ) > MAX_SPEED# Then Player\VY# = Sgn( Player\VY# )*MAX_SPEED#
		If Abs( Player\VZ# ) > MAX_SPEED# Then Player\VZ# = Sgn( Player\VZ# )*MAX_SPEED#
	Next
	
	DeltaTimer = MilliSecs()
	
	If SaveAccess( EntityX( LocalPlayer\Camera, True ), EntityY( LocalPlayer\Camera, True ), EntityZ( LocalPlayer\Camera, True ) ) = BLOCK_WATER Then
		CameraRange LocalPlayer\Camera, 0.1, 12
		CameraFogRange LocalPlayer\Camera, 6, 12
		CameraFogColor LocalPlayer\Camera, 0, 16, 32
		ClsColor 0, 16, 32
		CameraFogMode  LocalPlayer\Camera, 1
		
		HideEntity Skybox
	Else
		CameraRange LocalPlayer\Camera, 0.1, VisibilityRange
		CameraFogRange LocalPlayer\Camera, VisibilityRange*0.8, VisibilityRange
		CameraFogColor LocalPlayer\Camera, 222, 252, 255
		ClsColor 222, 252, 255
		CameraFogMode  LocalPlayer\Camera, 1
		
		ShowEntity Skybox
	EndIf
	
	PositionEntity Skybox, EntityX( LocalPlayer\Entity ), EntityY( LocalPlayer\Entity ), EntityZ( LocalPlayer\Entity )
End Function

Function DisconnectPlayer( Player.TPlayer )
	If CurrentState = STATE_GAME_MULTI Then AddChat( "Player " + Player\Name$ + " disconnected" )
	
	FreeEntity Player\Entity
	Delete Player
End Function

Function KickPlayer( Player.TPlayer )
	If Player = LocalPlayer Then RuntimeError "You have been kicked from the game"
	
	If CurrentState = STATE_GAME_MULTI Then AddChat( "Player " + Player\Name$ + " has been kicked" )
	
	FreeEntity Player\Entity
	Delete Player
End Function