Type TLog
	Field Message$
End Type

Type TChat
	Field Message$
End Type

Global FPSTimer = MilliSecs(), FPSCounter, FPS

Function StringStartsWith( Source$, Token$ )
	Return Left( Source$, Len( Token$ ) ) = Token$
End Function

Function RenderLog()
	Local Counter
	For Log.TLog = Each TLog
		Color 0, 0, 0
		Rect 0, Counter*20, GraphicsWidth(), 20
		
		Color 255, 255, 255
		Text 2, Counter*20 + 2, Log\Message$
		
		Counter = Counter + 1
	Next
End Function

Function AddLog( Message$ )
	Local Counter
	For Log.TLog = Each TLog
		Counter = Counter + 1
	Next
	
	If Counter > 3 Then Delete First TLog
	
	Log.TLog = New TLog
	Log\Message$ = Message$
End Function

Function AddChat( Message$ )
	Local Counter
	For Chat.TChat = Each TChat
		Counter = Counter + 1
	Next
	
	;While Counter > 7 - 2*( CurrentState = STATE_GAME_MULTI )
	;	Delete First TChat
	;	
	;	Counter = Counter - 1
	;Wend
	
	Chat.TChat = New TChat
	Chat\Message$ = Message$
End Function

Function GetFPS()
	FPSCounter = FPSCounter + 1
	
	If MilliSecs() - FPSTimer >= 1000 Then
		FPS = FPSCounter
		FPSCounter = 0
		FPSTimer = MilliSecs()
	EndIf
	
	Return FPS
End Function

Function IsNaN( Value# )
	Return Value = 1 And Value = 0
End Function

Function CountOccurenceInString( SourceString$, SearchString$ )
	Local Offset = Instr( SourceString$, SearchString$ )
	
	Local Count
	While Offset
		Count = Count + 1
		
		Offset = Instr( SourceString$, SearchString$, Offset + Len( SearchString$ ) )
	Wend
	
	Return Count
End Function

Function FindOccurenceInString$( SourceString$, SearchString$, Occurence )
	Local Offset = Instr( SourceString$, SearchString$ )
	
	Local Count
	While Offset
		Count = Count + 1
		
		If Count = Occurence Then Return Left( SourceString$, Offset )
		
		Offset = Instr( SourceString$, SearchString$, Offset + Len( SearchString$ ) )
	Wend
End Function

Function StripOccurenceInString$( SourceString$, SearchString$, Occurence )
	Local Offset = Instr( SourceString$, SearchString$ )
	
	Local Count
	While Offset
		Count = Count + 1
		
		If Count = Occurence Then Return Right( SourceString$, Len( SourceString$ ) - Offset )
		
		Offset = Instr( SourceString$, SearchString$, Offset + Len( SearchString$ ) )
	Wend
End Function

Function GetIntFromStringBank( Bank )
	Local Multiplier, Result
	For I = BankSize( Bank ) - 1 To 0 Step -1
		If ( Not Multiplier ) Then
			Local Byte = PeekByte( Bank, i )
			
			If Byte Then
				Multiplier = 1
				Result = Byte - Asc( "0" )
			EndIf
		Else
			Multiplier = Multiplier*10
			
			Result = Result + Multiplier*( PeekByte( Bank, I ) - Asc( "0" ) )
		EndIf
	Next
	
	Return Result
End Function

Function SaveScreenshot()
	If Not FileType( "Screenshots" ) Then CreateDir( "Screenshots" )
	
	LockBuffer FrontBuffer()
	SaveImageToPNG FrontBuffer(), "Screenshots\" + CurrentDate() + " " + Replace( CurrentTime(), ":", "-" ) + ".png", 9
	UnlockBuffer FrontBuffer()
End Function

Function MainWindowActive()
	Return API_GetActiveWindow() = SystemProperty( "AppHWND" )
End Function